<?php
namespace App\Models\Organization;
use App\Models\BaseModel;
use App\Libraries\ValueSet;

class AccountModel extends BaseModel {
  protected $table = 'account';
  protected $primaryKey = 'AccountID';
  protected $allowedFields = ['Parent', 'AccountName', 'Initial', 'Street_1', 'Street_2', 'Street_3', 
    'City', 'Province', 'ZIP', 'Country', 'AreaCode', 'EmailAddress1', 'EmailAddress2', 
    'Phone', 'Fax', 'CreateDate', 'EndDate']; 
		
  protected $useTimestamps = true;
  protected $createdField = 'CreateDate';
  protected $updatedField = '';
  protected $useSoftDeletes = true;
  protected $deletedField = 'EndDate';
   
  public function getAccounts($filter=[]) {
		$builder = $this->select('account.AccountID, account.AccountName, account.Parent, pa.AccountName as ParentName, account.Initial')
      ->join('account pa', 'pa.AccountID=account.Parent', 'left');

		if (!empty($filter['Parent'])) {
			$builder->where('account.Parent', $filter['Parent']);
		}
		if (!empty($filter['AccountName'])) {
			$builder->like('account.AccountName', $filter['AccountName'], 'both');
		}

		$rows = $builder->findAll();
    return $rows;
  }

  public function getAccount($AccountID) {
    $row = $this->select('account.*, pa.AccountName as ParentName, areageo.AreaName, areageo.AreaGeoID, 
			account.City as City, city.AreaName as CityLabel, account.Province as Province, prov.AreaName as ProvinceLabel')
      ->join('account pa', 'pa.AccountID=account.Parent', 'left')
      ->join('areageo', 'areageo.AreaCode=account.AreaCode', 'left')
      ->join('areageo city', 'city.AreaGeoID=account.City', 'left')
      ->join('areageo prov', 'prov.AreaGeoID=account.Province', 'left')
      ->where('account.AccountID', $AccountID)
      ->first();
    
    if (!$row) return null;
    
    $row = ValueSet::transformLabels([$row], [
      'Country' => 'account_Country',
    ])[0];
    
    return $row;
  }
}
